## kylin-process-manager 4.0.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(kylin-process-manager LANGUAGES CXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

add_subdirectory(process-manager)
add_subdirectory(process-manager-daemon)

set(QAPPLICATION_CLASS QCoreApplication  CACHE STRING "Inheritance class for SingleApplication")
add_subdirectory(third-party/SingleApplication)

=== process-manager-daemon/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(kylin-process-manager-daemon LANGUAGES CXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core DBus)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core DBus)

#set(QAPPLICATION_CLASS QCoreApplication CACHE STRING "Inheritance class for SingleApplication")

set (SRC_Sources
   main.cpp
   processmanager.cpp
   appmanagercgroupd.cpp
   resourcewatcher.cpp
   pressurewatcher.cpp
   systemresourcewatcher.cpp
   confmanager.cpp
   processreclaimer.cpp
)

set (SRC_Headers
    processmanager.h
    appmanagercgroupd.h
    resourcewatcher.h
    pressurewatcher.h
    systemresourcewatcher.h
    confmanager.h
    processreclaimer.h
    common.h)

qt5_add_dbus_adaptor(SRC_Sources configs/com.kylin.ProcessManagerDaemon.xml processmanager.h ProcessManager processmanagerservice ProcessManagerService)

add_executable(kylin-process-manager-daemon
  ${SRC_Sources}
  ${SRC_Headers}
)

target_link_libraries(kylin-process-manager-daemon
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    SingleApplication::SingleApplication
    cgroup
    proc2)

install(TARGETS kylin-process-manager-daemon DESTINATION /usr/bin)

=== process-manager/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(kylin-process-manager LANGUAGES CXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

add_definitions(-DQT_NO_KEYWORDS)
#set(QAPPLICATION_CLASS QApplication1 CACHE STRING "Inheritance class for SingleApplication")

find_package(PkgConfig REQUIRED)
find_package(KF5KIO)
find_package(KF5WindowSystem)
find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core Widgets DBus)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Widgets DBus)

pkg_check_modules(KYSDKWAYLANDHELPER_PKG kysdk-waylandhelper)
pkg_check_modules(GIO REQUIRED gio-unix-2.0)

include_directories(${GIO_INCLUDE_DIRS})
include_directories(src src/core src/utils src/dbusinterfaces src/dbusservices)
include_directories(../)

set (SRC_Sources
    src/core/appcgroup.cpp
    src/core/appinfo.cpp
    src/core/appinfomanager.cpp
    src/core/appstatusmanager.cpp
    src/core/basecontroller.cpp
    src/core/eventwatcher.cpp
    src/core/policy.cpp
    src/core/timerwheel.cpp
    src/dbusinterfaces/statusmanagerinterface.cpp
    src/main.cpp
    src/appmanager.cpp
    src/dbusinterfaces/cgroupinterface.cpp
    src/dbusinterfaces/kwininterface.cpp
    src/dbusservices/applauncher.cpp
    src/dbusservices/applauncherdaemon.cpp
    src/dbusservices/appmanagerservice.cpp
    src/dbusservices/whitelistmanager.cpp
    src/memorymonitor.cpp
    src/utils/misc.cpp
    src/utils/processinfo.cpp
)

set (SRC_Headers
    src/core/appcgroup.h
    src/core/appinfo.h
    src/core/appinfomanager.h
    src/core/appstatusmanager.h
    src/core/basecontroller.h
    src/core/eventwatcher.h
    src/core/policy.h
    src/core/timerwheel.h
    src/dbusinterfaces/statusmanagerinterface.h
    src/appmanager.h
    src/dbusinterfaces/cgroupinterface.h
    src/dbusinterfaces/kwininterface.h
    src/dbusservices/applauncher.h
    src/dbusservices/applauncherdaemon.h
    src/dbusservices/appmanagerservice.h
    src/dbusservices/whitelistmanager.h
    src/memorymonitor.h
    src/utils/misc.h
    src/utils/processinfo.h)

qt5_add_dbus_interface(SRC_Sources configs/com.kylin.ProcessManager.xml processmanagerinterface)

add_executable(kylin-process-manager
  ${SRC_Sources}
  ${SRC_Headers}
)

target_include_directories(kylin-process-manager PRIVATE ${KYSDKWAYLANDHELPER_PKG_INCLUDE_DIRS})
target_link_directories(kylin-process-manager PRIVATE ${KYSDKWAYLANDHELPER_PKG_LIBRARY_DIRS})

target_link_libraries(kylin-process-manager
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::DBus
    ${GIO_LIBRARIES}
    ${KYSDKWAYLANDHELPER_PKG_LIBRARIES}
    KF5::KIOCore
    KF5::WindowSystem
    SingleApplication::SingleApplication
    cgroup
    proc2
    spdlog
    ukui-log4qt)

install(TARGETS kylin-process-manager DESTINATION /usr/bin)

=== third-party/SingleApplication/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12.0)

project(SingleApplication LANGUAGES CXX DESCRIPTION "Replacement for QtSingleApplication")

set(CMAKE_AUTOMOC ON)

add_library(${PROJECT_NAME} STATIC
    singleapplication.cpp
    singleapplication_p.cpp
)
add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

if(NOT QT_DEFAULT_MAJOR_VERSION)
    set(QT_DEFAULT_MAJOR_VERSION 5 CACHE STRING "Qt version to use (5 or 6), defaults to 5")
endif()

# Find dependencies
set(QT_COMPONENTS Core Network)
set(QT_LIBRARIES Qt${QT_DEFAULT_MAJOR_VERSION}::Core Qt${QT_DEFAULT_MAJOR_VERSION}::Network)

message(QAPPLICATION_CLASS-is:${QAPPLICATION_CLASS})

if(QAPPLICATION_CLASS STREQUAL QApplication)
    list(APPEND QT_COMPONENTS Widgets)
    list(APPEND QT_LIBRARIES Qt${QT_DEFAULT_MAJOR_VERSION}::Widgets)
elseif(QAPPLICATION_CLASS STREQUAL QGuiApplication)
    list(APPEND QT_COMPONENTS Gui)
    list(APPEND QT_LIBRARIES Qt${QT_DEFAULT_MAJOR_VERSION}::Gui)
else()
    set(QAPPLICATION_CLASS QCoreApplication)
endif()

find_package(Qt${QT_DEFAULT_MAJOR_VERSION} COMPONENTS ${QT_COMPONENTS} REQUIRED)

option(SINGLEAPPLICATION_DOCUMENTATION "Generate Doxygen documentation" OFF)
if(SINGLEAPPLICATION_DOCUMENTATION)
    find_package(Doxygen)
endif()

target_link_libraries(${PROJECT_NAME} PUBLIC ${QT_LIBRARIES})

if(WIN32)
    target_link_libraries(${PROJECT_NAME} PRIVATE advapi32)
endif()

target_compile_definitions(${PROJECT_NAME} PUBLIC QAPPLICATION_CLASS=${QAPPLICATION_CLASS})
target_include_directories(${PROJECT_NAME} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_compile_definitions(${PROJECT_NAME} PRIVATE
    QT_NO_CAST_TO_ASCII
    QT_NO_CAST_FROM_ASCII
    QT_NO_URL_CAST_FROM_STRING
    QT_NO_CAST_FROM_BYTEARRAY
    QT_USE_QSTRINGBUILDER
    QT_NO_NARROWING_CONVERSIONS_IN_CONNECT
    QT_NO_KEYWORDS
    QT_NO_FOREACH
)

if(DOXYGEN_FOUND)
    # Doxygen theme
    include(FetchContent)
    FetchContent_Declare(DoxygenAwesome
        GIT_REPOSITORY https://github.com/jothepro/doxygen-awesome-css
        GIT_TAG 4cd62308d825fe0396d2f66ffbab45d0e247724c # 2.0.3
    )
    FetchContent_MakeAvailable(DoxygenAwesome)
    FetchContent_GetProperties(DoxygenAwesome SOURCE_DIR DoxygenAwesome_SOURCE_DIR)

    set(DOXYGEN_USE_MDFILE_AS_MAINPAGE README.md)
    set(DOXYGEN_GENERATE_TREEVIEW YES)
    set(DOXYGEN_HTML_HEADER ${DoxygenAwesome_SOURCE_DIR}/doxygen-custom/header.html)
    set(DOXYGEN_HTML_EXTRA_STYLESHEET ${DoxygenAwesome_SOURCE_DIR}/doxygen-awesome.css)
    set(DOXYGEN_HTML_EXTRA_FILES
        ${DoxygenAwesome_SOURCE_DIR}/doxygen-awesome-fragment-copy-button.js
        ${DoxygenAwesome_SOURCE_DIR}/doxygen-awesome-paragraph-link.js
        ${DoxygenAwesome_SOURCE_DIR}/doxygen-awesome-darkmode-toggle.js
    )

    doxygen_add_docs(${PROJECT_NAME}Documentation
        singleapplication.h
        CHANGELOG.md
        Windows.md
        README.md
    )
endif()

=== debian/changelog ===
kylin-process-manager (4.0.0.0-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:48:35 +1100

kylin-process-manager (4.0.0.0-1build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 05:32:26 +0000

kylin-process-manager (4.0.0.0-1) unstable; urgency=medium

  * 4.0.0.0 release.
  * Upload to unstable.

 -- pengfeiguo <pengfeiguo@openkylin.top>  Fri, 19 Jan 2024 10:55:08 +0800

kylin-process-manager (3.0.0-1) experimental; urgency=medium

  * Initial release. (Closes: #1032455)

 -- KevinDuan <duankaiwen@ubuntukylin.com>  Thu, 02 Mar 2023 13:41:30 +0800

=== debian/control ===
Source: kylin-process-manager
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: pengfeiguo <pengfeiguo@openkylin.top>
Uploaders: xibowen <xibowen@kylinos.cn>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libcgroup-dev,
               libglib2.0-dev,
               libgsettings-qt-dev,
               libkf5config-dev,
               libkf5kio-dev,
               libkf5wayland-dev,
               libkf5windowsystem-dev,
               libkysdk-applications-dev,
               libproc2-dev,
               libspdlog-dev,
               libukui-log4qt-dev,
               pkg-config,
               qtbase5-dev
Standards-Version: 4.6.1.0
Rules-Requires-Root: no
Homepage: https://gitee.com/openkylin/kylin-process-manager
Vcs-Git: https://gitee.com/openkylin/kylin-process-manager.git
Vcs-Browser: https://gitee.com/openkylin/kylin-process-manager

Package: kylin-process-manager
Architecture: any
Depends: kylin-process-manager-daemon,
         xdg-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Process manager for UKUI
 kylin-process-manager is responsible for application startup and limits
 resources for applications based on the status of the application window.
 It ensures that system components and focus application can obtain
 more system resources.

Package: kylin-process-manager-daemon
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Process manager daemon for UKUI
 kylin-process-manager-daemon is the backend service of kylin-process-manager,
 for managing the cgroups of application or process. It provides D-Bus APIs
 for kylin-process-manager.

=== debian/watch ===
version=4
https://gitee.com/openkylin/kylin-process-manager/releases/ .*/kylin-process-manager-(\d\S+)\.tar\.gz
